#include <DysectAPI.h>
#include <string>
#include <signal.h>

using namespace std;

DysectStatus DysectAPI::onProcStart(int argc, char **argv) {
  int value = 10;

  string libraryPath = "/collab/usr/global/tools/stat/toss_3_x86)64_ib/stat-test/lib/libdepositcorewrap.so", variableName = "globalMpiRank", functionName = "depositcore_wrap_signal_handler";

  Probe* p1    = new Probe(Code::location("mpi_ringtopo2.cpp#98"),
                           Domain::group("3-5,7"),
                           Act::totalview());

  Probe* p2    = new Probe(Code::location("mpi_ringtopo2.cpp#77"),
                           Domain::group("3-5,7"),
                           Acts(Act::trace("Location is '@location()'"),
                                Act::depositCore()));

  Probe* p3    = new Probe(Code::location("mpi_ringtopo2.cpp#77"),
                           Domain::group("3-5,7"),
                           Acts(Act::trace("Location is '@location()'"),
                                Act::loadLibrary(libraryPath),
                                Act::writeModuleVariable(libraryPath, variableName, (void *)&value, sizeof(int)),
                                Act::irpc(libraryPath, functionName, (void *)&value, sizeof(int))));
                                //Act::signal(SIGUSR1)));

  Probe *p4    = new Probe(Time::within(0),
                           Domain::group("7"),
                           Act::signal(SIGUSR1));

//  p3->link(p4);

  ProbeTree::addRoot(p1);
  ProbeTree::addRoot(p2);
//  ProbeTree::addRoot(p3);
  return DysectOK;
}
